'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _findIndex2 = require('lodash/findIndex');

var _findIndex3 = _interopRequireDefault(_findIndex2);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _pick = require('lodash/pick');

var _pick2 = _interopRequireDefault(_pick);

var _reactabularDnd = require('reactabular-dnd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var moveTreeRows = function moveTreeRows() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var sourceRowId = _ref.sourceRowId;
  var targetRowId = _ref.targetRowId;
  var _ref$retain = _ref.retain;
  var retain = _ref$retain === undefined ? [] : _ref$retain;
  var _ref$idField = _ref.idField;
  var idField = _ref$idField === undefined ? 'id' : _ref$idField;
  var _ref$parentField = _ref.parentField;
  var parentField = _ref$parentField === undefined ? 'parent' : _ref$parentField;
  return function (rows) {
    var movedRows = (0, _reactabularDnd.moveRows)({
      sourceRowId: sourceRowId,
      targetRowId: targetRowId
    })(rows);

    if (movedRows) {
      // Walk through the old row definition, patch parent relations and fields
      // of the new one
      movedRows = rows.map(function (row, i) {
        var _extends3;

        if (typeof row[parentField] === 'undefined' || row[parentField] === null) {
          var _extends2;

          return _extends({}, (0, _omit2.default)(movedRows[i], retain), (0, _pick2.default)(row, retain), (_extends2 = {}, _defineProperty(_extends2, idField, movedRows[i][idField]), _defineProperty(_extends2, parentField, undefined), _extends2));
        }

        // Find the index of the old parent
        var index = (0, _findIndex3.default)(rows, _defineProperty({}, idField, row[parentField]));

        if (index < 0) {
          console.warn( // eslint-disable-line no-console
          'Failed to find the old parent', rows, row, idField, parentField);

          return row;
        }

        // Figure out the new id based on that index
        var id = movedRows[index][idField];

        return _extends({}, (0, _omit2.default)(movedRows[i], retain), (0, _pick2.default)(row, retain), (_extends3 = {}, _defineProperty(_extends3, idField, movedRows[i][idField]), _defineProperty(_extends3, parentField, id), _extends3));
      });
    }

    return movedRows;
  };
};

exports.default = moveTreeRows;