'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _orderBy = require('lodash/orderBy');

var _orderBy2 = _interopRequireDefault(_orderBy);

var _redux = require('redux');

var _reactabularSort = require('reactabular-sort');

var _pack = require('./pack');

var _pack2 = _interopRequireDefault(_pack);

var _unpack = require('./unpack');

var _unpack2 = _interopRequireDefault(_unpack);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function sortTree() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var columns = _ref.columns;
  var idField = _ref.idField;
  var sortingColumns = _ref.sortingColumns;
  var strategy = _ref.strategy;

  return (0, _redux.compose)((0, _unpack2.default)({
    idField: idField
  }), (0, _reactabularSort.sorter)({
    columns: columns,
    sortingColumns: sortingColumns,
    sort: _orderBy2.default,
    strategy: strategy
  }), (0, _pack2.default)({
    idField: idField
  }));
}

exports.default = sortTree;