'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var unpack = function unpack() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var _ref$parentField = _ref.parentField;
  var parentField = _ref$parentField === undefined ? 'parent' : _ref$parentField;
  var _ref$childrenField = _ref.childrenField;
  var childrenField = _ref$childrenField === undefined ? 'children' : _ref$childrenField;
  var _ref$idField = _ref.idField;
  var idField = _ref$idField === undefined ? 'id' : _ref$idField;
  var parent = _ref.parent;
  return function (rows) {
    var _ref2;

    if (!Array.isArray(rows)) {
      return [];
    }

    if (!rows.length) {
      return rows;
    }

    return (_ref2 = []).concat.apply(_ref2, _toConsumableArray(rows.map(function (node) {
      var children = node[childrenField];
      var d = parent ? _extends({}, (0, _omit2.default)(node, childrenField), _defineProperty({}, parentField, parent)) : (0, _omit2.default)(node, childrenField);

      return [d].concat(unpack({
        parentField: parentField,
        parent: d[idField],
        idField: idField
      })(children));
    })));
  };
};

exports.default = unpack;